#ifndef BOOT_HEADER_H
#define BOOT_HEADER_H

#include <stdint.h>

#define BOOT_HEADER_SIGNATURE_VALID       0x46434642 /* FCFB */
#define BOOT_HEADER_CONFIG_INIT_SDRAM_Pos 0
#define BOOT_HEADER_CONFIG_INIT_SDRAM_Msk (1 << BOOT_HEADER_CONFIG_INIT_SDRAM_Pos)
#define BOOT_HEADER_CONFIG_KEEP_RTC_Pos   1
#define BOOT_HEADER_CONFIG_KEEP_RTC_Msk   (1 << BOOT_HEADER_CONFIG_KEEP_RTC_Msk)

typedef struct {
    uint32_t signature;
    uint32_t config;
    uint32_t base;
} boot_header_t;

#endif  // BOOT_HEADER_H
